align 16
u64_mul proc uses eax ecx edx edi esi q1:QWORD,q2:QWORD,lp_m128:DWORD
LOCAL tmp_m64:QWORD

; c = q1[1]*q2[1]*(2^64) + (q1[0]*q2[1] + q1[1]*q2[2])*(2^32) + q1[0]*q2[0]


    mov edi,lp_m128
    lea esi,tmp_m64

    mov eax,DWORD ptr q1
    mov edx,DWORD ptr q2
    mul edx
    mov DWORD ptr [edi]  ,eax
    mov DWORD ptr [edi+4],edx

    mov eax,DWORD ptr q1+4
    mov edx,DWORD ptr q2+4
    mul edx
    mov DWORD ptr [edi+8],eax
    mov DWORD ptr [edi+12],edx

    mov eax,DWORD ptr q1
    mov edx,DWORD ptr q2+4
    mul edx
    mov DWORD ptr [esi],eax
    mov DWORD ptr [esi+4],edx

    mov eax,DWORD ptr q1+4
    mov edx,DWORD ptr q2
    mul edx

    xor ecx,ecx
    add eax,DWORD ptr [esi]
    adc edx,DWORD ptr [esi+4]
    adc ecx,0

    add DWORD ptr [edi+4],eax
    adc DWORD ptr [edi+8],edx
    adc DWORD ptr [edi+12],ecx

    ret

u64_mul endp

align 16
u64_div proc uses  eax edx ecx edi esi Number:QWORD,Divisor:QWORD,lp_m64_Quotient:DWORD,lp_m64_Remainder:DWORD

    mov edi,lp_m64_Quotient
    mov esi,lp_m64_Remainder

   mov edx, DWORD ptr Number+4
   mov eax, DWORD ptr Number
   mov ecx, DWORD ptr Divisor
   .if edx < ecx
      div ecx
      mov DWORD ptr [edi], eax
      mov DWORD ptr [edi+4],0
      mov DWORD ptr [esi], edx
      mov DWORD ptr [esi+4],0
   .else
      mov eax, edx
      xor edx, edx
      div ecx
      mov DWORD ptr [edi+4], eax
      mov eax, DWORD ptr Number
      div ecx
      mov DWORD ptr [edi], eax
      mov DWORD ptr [esi], edx
      mov DWORD ptr [esi+4],0
   .endif

    ret

u64_div endp

align 16
u128_div proc uses eax edx ecx ebx edi esi lp_m128_Quotient:DWORD,lp_m128_Remainder:DWORD,lp_m128_Number:DWORD,lp_m128_Divisor:DWORD
;   Quotient = Dividend
;   Remainder = 0
;
;   for i=1 to NumberBits do
;
;      Remainder:Quotient = Remainder:Quotient SHL 1
;
;      if Remainder >= Divisor then
;         Remainder = Remainder - Divisor
;         Quotient = Quotient + 1
;      endif
;   endfor

    mov edi,lp_m128_Remainder
    xor eax,eax                                     ; Remainder = 0
    mov DWORD ptr [edi],eax                         ;
    mov DWORD ptr [edi+4],eax                       ;
    mov DWORD ptr [edi+8],eax                       ;
    mov DWORD ptr [edi+12],eax                      ;

    mov edi,lp_m128_Number                          ; copy Number to Qutient
    mov eax,DWORD ptr [edi]                         ;
    mov ebx,DWORD ptr [edi+4]                       ;
    mov ecx,DWORD ptr [edi+8]                       ;
    mov edx,DWORD ptr [edi+12]                      ;
                                                    ;
    mov edi,lp_m128_Quotient                        ;
    mov DWORD ptr [edi],eax                         ;
    mov DWORD ptr [edi+4],ebx                       ;
    mov DWORD ptr [edi+8],ecx                       ;
    mov DWORD ptr [edi+12],edx                      ;

    mov edi,lp_m128_Remainder
    push 128                                        ; loop through all 128 bits
    .while DWORD ptr [esp] != 0                     ;

        mov esi,lp_m128_Quotient                    ; Remainder:Quotient = Remainder:Quotient SHL 1
        shl DWORD ptr [esi],1                       ; (shl 256 bit by 1)
        rcl DWORD ptr [esi+4],1                     ;
        rcl DWORD ptr [esi+8],1                     ;
        rcl DWORD ptr [esi+12],1                    ;
        rcl DWORD ptr [edi],1                       ;
        rcl DWORD ptr [edi+4],1                     ;
        rcl DWORD ptr [edi+8],1                     ;
        rcl DWORD ptr [edi+12],1                    ;

        IF_GE_128 lp_m128_Remainder,lp_m128_Divisor ; .if Remainder >= Divisor

            mov esi,lp_m128_Divisor                 ; Remainder = Remainder - Divisor
            mov eax,DWORD ptr [esi]                 ;
            mov ebx,DWORD ptr [esi+4]               ;
            mov ecx,DWORD ptr [esi+8]               ;
            mov edx,DWORD ptr [esi+12]              ;
                                                    ;
            sub DWORD ptr [edi],eax                 ;
            sbb DWORD ptr [edi+4],ebx               ;
            sbb DWORD ptr [edi+8],ecx               ;
            sbb DWORD ptr [edi+12],edx              ;

                                                    ; Quotient = Quotient + 1
            mov eax,lp_m128_Quotient                ;
            add DWORD ptr [eax],1                   ;
            adc DWORD ptr [eax+4],0                 ;
            adc DWORD ptr [eax+8],0                 ;
            adc DWORD ptr [eax+12],0                ;

            align 16
        ENDIF_GE_128

        dec DWORD ptr [esp]
    .endw

    add esp,4
    ret

u128_div endp

align 16
u128_add proc uses eax ecx edx edi esi ebx lp_m128_Dest:DWORD,lp_m128_1:DWORD,lp_m128_2:DWORD

    mov edi,lp_m128_Dest
    mov esi,lp_m128_1
    mov ebx,lp_m128_2

    mov eax,DWORD ptr [esi]
    mov edx,DWORD ptr [esi+4]
    mov ecx,DWORD ptr [esi+8]

    add eax,DWORD ptr [ebx]
    adc edx,DWORD ptr [ebx+4]
    adc ecx,DWORD ptr [ebx+8]

    mov DWORD ptr [edi],eax
    mov DWORD ptr [edi+4],edx
    mov DWORD ptr [edi+8],ecx

    mov eax,DWORD ptr [esi+12]
    adc eax,DWORD ptr [ebx+12]
    mov DWORD ptr [edi+12],eax

    ret

u128_add endp

align 16
u128_sub proc uses eax ecx edx edi esi ebx lp_m128_Dest:DWORD,lp_m128_1:DWORD,lp_m128_2:DWORD

    mov edi,lp_m128_Dest
    mov esi,lp_m128_1
    mov ebx,lp_m128_2

    mov eax,DWORD ptr [esi]
    mov edx,DWORD ptr [esi+4]
    mov ecx,DWORD ptr [esi+8]

    sub eax,DWORD ptr [ebx]
    sbb edx,DWORD ptr [ebx+4]
    sbb ecx,DWORD ptr [ebx+8]

    mov DWORD ptr [edi],eax
    mov DWORD ptr [edi+4],edx
    mov DWORD ptr [edi+8],ecx

    mov eax,DWORD ptr [esi+12]
    sbb eax,DWORD ptr [ebx+12]
    mov DWORD ptr [edi+12],eax

    ret
u128_sub endp

align 16
u64_log2 proc uses eax ecx edi esi lp_m64_Dest:DWORD,lp_qWord:DWORD


    mov edi,lp_m64_Dest
	mov esi,lp_qWord

	xor eax,eax
	mov ecx,32
@@:	bsr eax,DWORD ptr [esi+4]
	jnz @F
	lea ecx,[ecx-32]
	bsr eax,DWORD ptr [esi]
@@:	lea eax,[eax+ecx]

    mov DWORD ptr [edi],eax
    mov DWORD ptr [edi+4],0

    ret

u64_log2 endp

align 16
u128_log2 proc uses eax ecx edi esi lp_m128_Dest:DWORD,lp_m128_Src:DWORD


    mov edi,lp_m128_Dest
	mov esi,lp_m128_Src

	xor eax,eax
	mov ecx,3*32
@@:	bsr eax,DWORD ptr [esi+12]
	jnz @F
	lea ecx,[ecx-32]
	bsr eax,DWORD ptr [esi+8]
	jnz @F
	lea ecx,[ecx-32]
	bsr eax,DWORD ptr [esi+4]
	jnz @F
	lea ecx,[ecx-32]
	bsr eax,DWORD ptr [esi]
@@:	lea eax,[eax+ecx]

    mov DWORD ptr [edi],eax
    mov DWORD ptr [edi+4],0
    mov DWORD ptr [edi+8],0
    mov DWORD ptr [edi+12],0

    ret

u128_log2 endp

align 16
u64_make_odd proc uses ecx edx ebx lp_m64_Dest:DWORD,q1:QWORD
;return: eax == n

    lea eax,q1
    mov edx,DWORD ptr [eax+4]
    mov eax,DWORD ptr [eax]
    xor ebx,ebx
@@: test eax,1
    jnz @F
    shrd eax,edx,1
    shr edx,1
    inc ebx
    jmp @B
@@:
    mov ecx,lp_m64_Dest
    mov DWORD ptr [ecx],eax
    mov DWORD ptr [ecx+4],edx

    mov eax,ebx
    ret

u64_make_odd endp

align 16
u128_shr proc uses eax ebx ecx edx esi edi lp_m128_Dest:DWORD,lp_m128_Src:DWORD,shift_value:DWORD

    .if shift_value <= 32

        mov esi,lp_m128_Src
        mov ecx,shift_value

        mov eax,DWORD ptr [esi]
        mov edx,DWORD ptr [esi+4]
        mov ebx,DWORD ptr [esi+8]
        mov edi,DWORD ptr [esi+12]

        shrd eax,edx,cl
        shrd edx,ebx,cl
        shrd ebx,edi,cl
        shr  edi,cl

        mov esi,lp_m128_Dest
        mov DWORD ptr [esi],eax
        mov DWORD ptr [esi+4],edx
        mov DWORD ptr [esi+8],ebx
        mov DWORD ptr [esi+12],edi

    .elseif shift_value <= 64

        mov esi,lp_m128_Src
        mov eax,lp_m128_Dest
        mov ecx,shift_value
        sub ecx,32

        mov edx,DWORD ptr [esi+4]
        mov ebx,DWORD ptr [esi+8]
        mov edi,DWORD ptr [esi+12]

        shrd edx,ebx,cl
        shrd ebx,edi,cl
        shr  edi,cl


        mov DWORD ptr [eax],edx
        mov DWORD ptr [eax+4],ebx
        mov DWORD ptr [eax+8],edi
        mov DWORD ptr [eax+12],0

    .elseif shift_value <= 96

        mov esi,lp_m128_Src
        mov eax,lp_m128_Dest
        mov ecx,shift_value
        sub ecx,64

        mov ebx,DWORD ptr [esi+8]
        mov edi,DWORD ptr [esi+12]

        shrd ebx,edi,cl
        shr  edi,cl


        mov DWORD ptr [eax],ebx
        mov DWORD ptr [eax+4],edi
        mov DWORD ptr [eax+8],0
        mov DWORD ptr [eax+12],0

    .elseif shift_value <= 128

        mov esi,lp_m128_Src
        mov eax,lp_m128_Dest
        mov ecx,shift_value
        sub ecx,96

        mov edi,DWORD ptr [esi+12]

        shr  edi,cl

        mov DWORD ptr [eax],edi
        mov DWORD ptr [eax+4],0
        mov DWORD ptr [eax+8],0
        mov DWORD ptr [eax+12],0

    .else
        mov eax,lp_m128_Dest
        mov DWORD ptr [eax],0
        mov DWORD ptr [eax+4],0
        mov DWORD ptr [eax+8],0
        mov DWORD ptr [eax+12],0
    .endif

    ret

u128_shr endp

align 16
u128_shl proc uses eax ebx ecx edx esi edi lp_m128_Dest:DWORD,lp_m128_Src:DWORD,shift_value:DWORD

    .if shift_value <= 32

        mov esi,lp_m128_Src
        mov ecx,shift_value

        mov eax,DWORD ptr [esi]
        mov edx,DWORD ptr [esi+4]
        mov ebx,DWORD ptr [esi+8]
        mov edi,DWORD ptr [esi+12]

        shld edi,ebx,cl
        shld ebx,edx,cl
        shld edx,eax,cl
        shl eax,cl

        mov esi,lp_m128_Dest
        mov DWORD ptr [esi],eax
        mov DWORD ptr [esi+4],edx
        mov DWORD ptr [esi+8],ebx
        mov DWORD ptr [esi+12],edi

        align 16
    .elseif shift_value <= 64

        mov esi,lp_m128_Src
        mov edi,lp_m128_Dest
        mov ecx,shift_value
        sub ecx,32

        mov eax,DWORD ptr [esi]
        mov edx,DWORD ptr [esi+4]
        mov ebx,DWORD ptr [esi+8]

        shld ebx,edx,cl
        shld edx,eax,cl
        shl eax,cl

        mov DWORD ptr [edi],0
        mov DWORD ptr [edi+4],eax
        mov DWORD ptr [edi+8],edx
        mov DWORD ptr [edi+12],ebx

        align 16
    .elseif shift_value <= 96

        mov esi,lp_m128_Src
        mov edi,lp_m128_Dest
        mov ecx,shift_value
        sub ecx,64

        mov eax,DWORD ptr [esi]
        mov edx,DWORD ptr [esi+4]

        shld edx,eax,cl
        shl eax,cl

        mov DWORD ptr [edi],0
        mov DWORD ptr [edi+4],0
        mov DWORD ptr [edi+8],eax
        mov DWORD ptr [edi+12],edx

        align 16
    .elseif shift_value <= 128

        mov esi,lp_m128_Src
        mov edi,lp_m128_Dest
        mov ecx,shift_value
        sub ecx,96

        mov eax,DWORD ptr [esi]

        shld edx,eax,cl
        shl eax,cl

        mov DWORD ptr [edi],0
        mov DWORD ptr [edi+4],0
        mov DWORD ptr [edi+8],0
        mov DWORD ptr [edi+12],eax

        align 16
    .else
        mov edi,lp_m128_Dest
        mov DWORD ptr [edi],0
        mov DWORD ptr [edi+4],0
        mov DWORD ptr [edi+8],0
        mov DWORD ptr [edi+12],0
    .endif


    ret

u128_shl endp
